<template>
<v-dialog :value="value" @input="$emit('input')" scrollable max-width="700px" persistent>
    <v-card>
        <v-card-text>
            <div>
                <div class="fields">
                    <st-title text="Fecha y hora de la cita"/>
                    <div class="content-body">
                        <v-row>
                            <v-col>
                                <v-label>Nombre del Alumno</v-label>
                            </v-col>
                            <v-col>
                                <v-label>{{info.alumno}}</v-label>
                            </v-col>
                        </v-row>
                        <v-row>
                            <v-col>
                                <v-label>Nombre de Tutoría</v-label>
                            </v-col>
                            <v-col>
                                <v-label>{{info.nombreTutoria}}</v-label>
                            </v-col>
                        </v-row>
                        <v-row class="textAlertFalse" v-if="alertOk == false">
                            <v-col align="center" md="12"><v-label>{{ alertMessage }}</v-label></v-col>
                        </v-row>
                        <v-row class="textAlertTrue" v-if="alertOk == true">
                            <v-col align="center" md="12"><v-label>{{ alertMessage }}</v-label></v-col>
                        </v-row>
                    </div>
                    <st-calendar ref="calendar" styleInterval="workday" :idTutor ="idTutor" :currUnit = "currUnit" :height="450"/>

                </div>

                <div class="content-footer">
                    <st-secondary-btn nombre="Cancelar" @click="$emit('input')"/>
                    <st-primary-btn
                        nombre="Registrar cita"
                        @click="sendToRegisterAppointment"
                        :loading="loading"
                        :disable="!alertOk"
                    />
                </div>
            </div>
        </v-card-text>
    </v-card>
</v-dialog>
</template>

<script>
import Calendar from "@/components/Calendar";
import {mapState} from "vuex";

export default {

    components:{
        'st-calendar': Calendar,
    },
    props:{
        value: Boolean,
        info : {}, //acá está el idAlumno, nombreAlumno, idTutoria,nombreTutoria
    },
    data(){
        return{
            alertMessage: "",
            alertOk:true,
            loading:false,
            idTutor: this.$store.state.role.id,
            currUnit : ""
        }
    },
    watch:{

    },
    methods:{
        async sendToRegisterAppointment(){

            try{
                this.loading=true;
                let event = [...this.$refs.calendar.getEvents()].pop();
                let payload = {
                    idTutor: this.idTutor,
                    start: new Date(event.start).toISOString(),
                    end:   new Date(event.end).toISOString(),
                };
                let toSend = {
                    alumnos: [this.info.idAlumno],
                    idUnidad: this.info.idUnidad,
                    idTutoria: this.info.idTutoria,
                    sesion: {
                        idTutorAsignado: payload.idTutor,
                        fechaInicio: payload.start,
                        fechaFin: payload.end
                    }
                };
                const response = await this.$api.registerAppointment(toSend);
                this.$emit('refresh');

            } catch(e) {console.error(e);}
            this.loading=false


        },
        ini(){
            if (this.info.nombreTutoria === 'Tutoría de Momento'){
                this.alertOk=false
                this.alertMessage="No es posible registrar por este medio una Tutoría de Momento. Seleccionar la opción del menú 'Tutoría de Momento'"
            }else{
                this.alertOk=true
                this.alertMessage="Registra una cita en el siguiente horario"
            }

        }

    },
    mounted(){
        this.ini()
        this.currUnit = this.info.idUnidad
    }
}
</script>

<style scoped lang="scss">
/* scope for encapsulate css */
    .textAlertFalse{
        border: 1px solid red;
    }
    .textAlertTrue{
        border: 1px solid green;
    }
</style>
